Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/ICE/iceistate.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/ICE/iceistate.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/ICE/iceistate.F90	(revision 14200)
@@ -22,5 +22,7 @@
    USE eosbn2         ! equation of state
 # if defined key_qco
-   USE domqco         ! Variable volume
+   USE domqco         ! Quasi-Eulerian coord.
+# elif defined key_linssh
+   !                  ! Fix in time coord.
 # else
    USE domvvl         ! Variable volume
@@ -424,5 +426,7 @@
          !
 #if defined key_qco
-         IF( .NOT.ln_linssh )   CALL dom_qco_zgr( Kbb, Kmm )        ! interpolation scale factor, depth and water column
+         IF( .NOT.ln_linssh )   CALL dom_qco_zgr( Kbb, Kmm )        ! upadte of r3=ssh/h0 ratios
+#elif defined key_linssh
+         !                                                          ! fix in time coord. : no update of vertical coord.
 #else
          IF( .NOT.ln_linssh )   CALL dom_vvl_zgr( Kbb, Kmm, Kaa )   ! interpolation scale factor, depth and water column
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_ice_interp.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_ice_interp.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_ice_interp.F90	(revision 14200)
@@ -69,24 +69,7 @@
       Agrif_UseSpecialValue = .FALSE.
       ! lbc ????
-      ! JC: do we really need the 3 lines below ?
+      !
       CALL ice_var_glo2eqv
-      CALL ice_var_zapsmall
-      CALL ice_var_agg(2)
-
-      ! Melt ponds
-      WHERE( a_i > epsi10 )
-         a_ip_frac(:,:,:) = a_ip(:,:,:) / a_i(:,:,:)
-      ELSEWHERE
-         a_ip_frac(:,:,:) = 0._wp
-      END WHERE
-      WHERE( a_ip > 0._wp )       ! ???????    
-         h_ip(:,:,:) = v_ip(:,:,:) / a_ip(:,:,:)
-      ELSEWHERE
-         h_ip(:,:,:) = 0._wp
-      END WHERE   
-
-      tn_ice(:,:,:) = t_su(:,:,:)
-      t1_ice(:,:,:) = t_i (:,:,1,:) 
-
+      !
    END SUBROUTINE agrif_istate_ice
 
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_interp.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_interp.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_interp.F90	(revision 14200)
@@ -76,7 +76,4 @@
       IF(lwp) WRITE(numout,*) ' '
 
-      IF ( ln_rstart ) & 
-         & CALL ctl_stop('AGRIF hot start should be desactivated in restarting mode')
-
       IF ( .NOT.Agrif_Parent(l_1st_euler) ) & 
          & CALL ctl_stop('AGRIF hot start requires to force Euler first step on parent')
@@ -86,13 +83,11 @@
       Agrif_UseSpecialValue = .TRUE.
 
-      ts(:,:,:,:,:) = 0.0_wp
-      uu(:,:,:,:)   = 0.0_wp
-      vv(:,:,:,:)   = 0.0_wp 
-      ssh(:,:,:)    = 0._wp
+      ts(:,:,:,:,Kbb) = 0.0_wp
+      uu(:,:,:,Kbb)   = 0.0_wp
+      vv(:,:,:,Kbb)   = 0.0_wp 
        
       Krhs_a = Kbb   ;   Kmm_a = Kbb
 
       CALL Agrif_Init_Variable(tsini_id, procname=interptsn)
-      CALL Agrif_Init_Variable(sshini_id, procname=interpsshn)
 
       Agrif_UseSpecialValue = ln_spc_dyn
@@ -108,6 +103,4 @@
       Krhs_a = Kaa   ;   Kmm_a = Kmm
 
-      ssh(:,:,Kbb) = ssh(:,:,Kbb) * tmask(:,:,1)
-
       DO jn = 1, jpts
          ts(:,:,:,jn,Kbb) = ts(:,:,:,jn,Kbb) * tmask(:,:,:)
@@ -118,10 +111,9 @@
       CALL lbc_lnk_multi( 'agrif_istate_oce', uu(:,:,:  ,Kbb), 'U', -1.0_wp , vv(:,:,:,Kbb), 'V', -1.0_wp )
       CALL lbc_lnk( 'agrif_istate_oce', ts(:,:,:,:,Kbb), 'T',  1.0_wp )
-      CALL lbc_lnk( 'agrif_istate_oce', ssh(:,:,Kbb), 'T', 1.0_wp )
 
    END SUBROUTINE Agrif_istate_oce
 
 
-   SUBROUTINE Agrif_istate_ssh( Kbb, Kmm )
+   SUBROUTINE Agrif_istate_ssh( Kbb, Kmm, Kaa )
       !!----------------------------------------------------------------------
       !!                 *** ROUTINE agrif_istate_ssh ***
@@ -132,5 +124,5 @@
       IMPLICIT NONE
       !
-      INTEGER, INTENT(in)  :: Kbb, Kmm 
+      INTEGER, INTENT(in)  :: Kbb, Kmm, Kaa 
       !!----------------------------------------------------------------------
       IF(lwp) WRITE(numout,*) ' '
@@ -139,22 +131,25 @@
       IF(lwp) WRITE(numout,*) ' '
 
-      IF ( ln_rstart ) & 
-         & CALL ctl_stop('AGRIF hot start should be desactivated in restarting mode')
-
       IF ( .NOT.Agrif_Parent(l_1st_euler) ) & 
          & CALL ctl_stop('AGRIF hot start requires to force Euler first step on parent')
 
-      Kmm_a = Kmm
-      ssh(:,:,Kmm) = 0._wp
-
+      Krhs_a = Kbb   ;   Kmm_a = Kbb
+      !
       Agrif_SpecialValue    = 0._wp
       Agrif_UseSpecialValue = .TRUE.
       l_ini_child           = .TRUE.
       !
+      ssh(:,:,Kbb) = 0._wp
       CALL Agrif_Init_Variable(sshini_id, procname=interpsshn)
       !
       Agrif_UseSpecialValue = .FALSE.
       l_ini_child           = .FALSE.
-      CALL lbc_lnk( 'dom_vvl_rst', ssh(:,:,Kmm), 'T', 1._wp )
+      !
+      Krhs_a = Kaa   ;   Kmm_a = Kmm
+      !
+      CALL lbc_lnk( 'Agrif_istate_ssh', ssh(:,:,Kbb), 'T', 1._wp )
+      !
+      ssh(:,:,Kmm) = ssh(:,:,Kbb)
+      ssh(:,:,Kaa) = 0._wp
 
    END SUBROUTINE Agrif_istate_ssh
@@ -203,5 +198,6 @@
 
       IF( .NOT.ln_dynspg_ts ) THEN ! Get transports
-         ubdy(:,:) = 0._wp   ;   vbdy(:,:) = 0._wp 
+         ubdy(:,:) = 0._wp    ;  vbdy(:,:) = 0._wp
+         utint_stage(:,:) = 0 ;  vtint_stage(:,:) = 0
          CALL Agrif_Bc_variable( unb_interp_id, procname=interpunb )
          CALL Agrif_Bc_variable( vnb_interp_id, procname=interpvnb )
@@ -274,10 +270,4 @@
          IF( .NOT.ln_dynspg_ts ) THEN 
             DO ji = mi0(ibdy1), mi1(ibdy2)
-               uu_b(ji,:,Krhs_a) = 0._wp
-               DO jk = 1, jpkm1
-                  DO jj = 1, jpj
-                     uu_b(ji,jj,Krhs_a) = uu_b(ji,jj,Krhs_a) + e3u(ji,jj,jk,Krhs_a) * uu(ji,jj,jk,Krhs_a) * umask(ji,jj,jk)
-                  END DO
-               END DO
                DO jj = 1, jpj
                   uu_b(ji,jj,Krhs_a) = ubdy(ji,jj) * r1_hu(ji,jj,Krhs_a)
@@ -304,13 +294,8 @@
          !
          ibdy1 = jpiglo - ( nn_hls + nbghostcells ) - nn_shift_bar*Agrif_Rhox() 
-         ibdy2 = jpiglo - ( nn_hls + 1 )              !
+         ibdy2 = jpiglo - ( nn_hls + 1 )     
+         !
          IF( .NOT.ln_dynspg_ts ) THEN 
             DO ji = mi0(ibdy1), mi1(ibdy2)
-               vv_b(ji,:,Krhs_a) = 0._wp
-               DO jk = 1, jpkm1
-                  DO jj = 1, jpj
-                     vv_b(ji,jj,Krhs_a) = vv_b(ji,jj,Krhs_a) + e3v(ji,jj,jk,Krhs_a) * vv(ji,jj,jk,Krhs_a) * vmask(ji,jj,jk)
-                  END DO
-               END DO
                DO jj = 1, jpj
                   vv_b(ji,jj,Krhs_a) = vbdy(ji,jj) * r1_hv(ji,jj,Krhs_a)
@@ -318,5 +303,5 @@
             END DO
          ENDIF
-
+         !
          DO ji = mi0(ibdy1), mi1(ibdy2)
             zvb(ji,:) = 0._wp
@@ -345,13 +330,7 @@
          IF( .NOT.ln_dynspg_ts ) THEN
             DO jj = mj0(jbdy1), mj1(jbdy2)
-               vv_b(:,jj,Krhs_a) = 0._wp
-               DO jk = 1, jpkm1
-                  DO ji = 1, jpi
-                     vv_b(ji,jj,Krhs_a) = vv_b(ji,jj,Krhs_a) + e3v(ji,jj,jk,Krhs_a) * vv(ji,jj,jk,Krhs_a) * vmask(ji,jj,jk)
-                  END DO
-               END DO
-               DO ji=1,jpi
-                  vv_b(ji,jj,Krhs_a) = vv_b(ji,jj,Krhs_a) * r1_hv(ji,jj,Krhs_a) 
-                  uu_b(ji,jj,Krhs_a) = uu_b(ji,jj,Krhs_a) * r1_hu(ji,jj,Krhs_a)
+               DO ji = 1, jpi
+                  uu_b(ji,jj,Krhs_a) = ubdy(ji,jj) * r1_hu(ji,jj,Krhs_a)
+                  vv_b(ji,jj,Krhs_a) = vbdy(ji,jj) * r1_hv(ji,jj,Krhs_a)
                END DO
             END DO
@@ -401,11 +380,5 @@
          IF( .NOT.ln_dynspg_ts ) THEN
             DO jj = mj0(jbdy1), mj1(jbdy2)
-               vv_b(:,jj,Krhs_a) = 0._wp
-               DO jk = 1, jpkm1
-                  DO ji = 1, jpi
-                     vv_b(ji,jj,Krhs_a) = vv_b(ji,jj,Krhs_a) + e3v(ji,jj,jk,Krhs_a) * vv(ji,jj,jk,Krhs_a) * vmask(ji,jj,jk)
-                  END DO
-               END DO
-               DO ji=1,jpi
+               DO ji = 1, jpi
                   vv_b(ji,jj,Krhs_a) = vbdy(ji,jj) * r1_hv(ji,jj,Krhs_a)
                END DO
@@ -432,18 +405,13 @@
          jbdy1 = jpjglo - ( nn_hls + nbghostcells ) - nn_shift_bar*Agrif_Rhoy()  
          jbdy2 = jpjglo - ( nn_hls + 1 )
+         !
          IF( .NOT.ln_dynspg_ts ) THEN
             DO jj = mj0(jbdy1), mj1(jbdy2)
-               uu_b(:,jj,Krhs_a) = 0._wp
-               DO jk = 1, jpkm1
-                  DO ji = 1, jpi
-                     uu_b(ji,jj,Krhs_a) = uu_b(ji,jj,Krhs_a) + e3u(ji,jj,jk,Krhs_a) * uu(ji,jj,jk,Krhs_a) * umask(ji,jj,jk)
-                  END DO
-               END DO
-               DO ji=1,jpi
+               DO ji = 1, jpi
                   uu_b(ji,jj,Krhs_a) = ubdy(ji,jj) * r1_hu(ji,jj,Krhs_a)
                END DO
             END DO
          ENDIF
-
+         !
          DO jj = mj0(jbdy1), mj1(jbdy2)
             zub(:,jj) = 0._wp
@@ -651,9 +619,10 @@
       IF( ll_int_cons ) THEN  ! Conservative interpolation
          IF ( lk_tint2d_notinterp ) THEN
+            Agrif_UseSpecialValue = .FALSE.
             CALL Agrif_Bc_variable( ub2b_interp_id, calledweight=1._wp, procname=interpub2b_const )
             CALL Agrif_Bc_variable( vb2b_interp_id, calledweight=1._wp, procname=interpvb2b_const ) 
             ! Divergence conserving correction terms:
-            CALL Agrif_Bc_variable(    ub2b_cor_id, calledweight=1._wp, procname=        ub2b_cor )
-            CALL Agrif_Bc_variable(    vb2b_cor_id, calledweight=1._wp, procname=        vb2b_cor )
+            IF ( Agrif_Rhox()>1 ) CALL Agrif_Bc_variable(    ub2b_cor_id, calledweight=1._wp, procname=ub2b_cor )
+            IF ( Agrif_Rhoy()>1 ) CALL Agrif_Bc_variable(    vb2b_cor_id, calledweight=1._wp, procname=vb2b_cor )
          ELSE
             ! order matters here !!!!!!
@@ -990,5 +959,5 @@
       ELSE
          IF( l_ini_child ) THEN
-            ssh(i1:i2,j1:j2,Kmm_a) = ptab(i1:i2,j1:j2) * tmask(i1:i2,j1:j2,1)
+            ssh(i1:i2,j1:j2,Krhs_a) = ptab(i1:i2,j1:j2) * tmask(i1:i2,j1:j2,1)
          ELSE
             hbdy(i1:i2,j1:j2) = ptab(i1:i2,j1:j2) * tmask(i1:i2,j1:j2,1)
@@ -1438,5 +1407,5 @@
          ptab(:,:) = 0._wp
          DO ji=i1+1,i2-1
-            DO jj=j1+1,j2
+            DO jj=j1+1,j2-1
                ptab(ji,jj) = 0.25_wp*( ( vb2_b(ji+1,jj  )*e1v(ji+1,jj  )   & 
                            &            -vb2_b(ji-1,jj  )*e1v(ji-1,jj  ) ) &
@@ -1542,5 +1511,5 @@
          ptab(:,:) = 0._wp
          DO ji=i1+1,i2-1
-            DO jj=j1+1,j2
+            DO jj=j1+1,j2-1
                ptab(ji,jj) = 0.25_wp*( ( ub2_b(ji  ,jj+1)*e2u(ji  ,jj+1)   & 
                            &            -ub2_b(ji  ,jj-1)*e2u(ji  ,jj-1) ) &
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_sponge.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_sponge.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_sponge.F90	(revision 14200)
@@ -441,20 +441,21 @@
                   N_in = mbkt_parent(ji,jj)
                   ! Input grid (account for partial cells if any):
-                  DO jk=1,N_in
-                     z_in(jk) = tabres(ji,jj,jk,n2) - tabres(ji,jj,k2,n2)
-                     tabin(jk,1:jpts) = tabres(ji,jj,jk,1:jpts)
-                  END DO
+                  IF ( N_in > 0 ) THEN 
+                     DO jk=1,N_in
+                        z_in(jk) = tabres(ji,jj,jk,n2) - tabres(ji,jj,k2,n2)
+                        tabin(jk,1:jpts) = tabres(ji,jj,jk,1:jpts)
+                     END DO
                   
-                  ! Intermediate grid:
-                  DO jk = 1, N_in
-                     h_in_i(jk) = e3t0_parent(ji,jj,jk) * & 
-                       &       (1._wp + tabres(ji,jj,k2,n2)/(ht0_parent(ji,jj)*ssmask(ji,jj) + 1._wp - ssmask(ji,jj)))
-                  END DO
-                  z_in_i(1) = 0.5_wp * h_in_i(1)
-                  DO jk=2,N_in
-                     z_in_i(jk) = z_in_i(jk-1) + 0.5_wp * ( h_in_i(jk) + h_in_i(jk-1) )
-                  END DO
-                  z_in_i(1:N_in) = z_in_i(1:N_in)  - tabres(ji,jj,k2,n2)
-
+                     ! Intermediate grid:
+                     DO jk = 1, N_in
+                        h_in_i(jk) = e3t0_parent(ji,jj,jk) * & 
+                          &       (1._wp + tabres(ji,jj,k2,n2)/(ht0_parent(ji,jj)*ssmask(ji,jj) + 1._wp - ssmask(ji,jj)))
+                     END DO
+                     z_in_i(1) = 0.5_wp * h_in_i(1)
+                     DO jk=2,N_in
+                        z_in_i(jk) = z_in_i(jk-1) + 0.5_wp * ( h_in_i(jk) + h_in_i(jk-1) )
+                     END DO
+                     z_in_i(1:N_in) = z_in_i(1:N_in)  - tabres(ji,jj,k2,n2)
+                  END IF
                   ! Output (Child) grid:
                   N_out = mbkt(ji,jj)
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_update.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_update.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_update.F90	(revision 14200)
@@ -192,5 +192,11 @@
       IF (lwp.AND.lk_agrif_debug) Write(*,*) 'Update e3 from grid Number',Agrif_Fixed(), 'Step', Agrif_Nb_Step()
       !
-#if ! defined key_qco
+#if defined key_qco
+      CALL Agrif_ChildGrid_To_ParentGrid()
+      CALL Agrif_Update_qco
+      CALL Agrif_ParentGrid_To_ChildGrid()
+#elif defined key_linssh
+      !
+#else
       Agrif_UseSpecialValueInUpdate = .TRUE.
       Agrif_SpecialValueFineGrid = 0.
@@ -204,8 +210,4 @@
       CALL Agrif_ChildGrid_To_ParentGrid()
       CALL dom_vvl_update_UVF
-      CALL Agrif_ParentGrid_To_ChildGrid()
-#else
-      CALL Agrif_ChildGrid_To_ParentGrid()
-      CALL Agrif_Update_qco
       CALL Agrif_ParentGrid_To_ChildGrid()
 #endif
@@ -232,5 +234,5 @@
 
 
-#if ! defined key_qco
+#if ! defined key_qco   &&   ! defined key_linssh
    SUBROUTINE dom_vvl_update_UVF
       !!---------------------------------------------
@@ -1163,5 +1165,5 @@
    END SUBROUTINE updateAVM
 
-#if ! defined key_qco
+#if ! defined key_qco   &&   ! defined key_linssh
    SUBROUTINE updatee3t(ptab_dum, i1, i2, j1, j2, k1, k2, before )
       !!---------------------------------------------
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_top_interp.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_top_interp.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_top_interp.F90	(revision 14200)
@@ -27,4 +27,6 @@
    PUBLIC Agrif_trc, interptrn
 
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
   !!----------------------------------------------------------------------
    !! NEMO/NST 4.0 , NEMO Consortium (2018)
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_top_sponge.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_top_sponge.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_top_sponge.F90	(revision 14200)
@@ -30,4 +30,6 @@
    PUBLIC Agrif_Sponge_trc, interptrn_sponge
 
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/NST 4.0 , NEMO Consortium (2018)
@@ -128,20 +130,21 @@
                   N_in = mbkt_parent(ji,jj)
                   ! Input grid (account for partial cells if any):
-                  DO jk=1,N_in
-                     z_in(jk) = tabres(ji,jj,jk,n2) - tabres(ji,jj,k2,n2)
-                     tabin(jk,1:jptra) = tabres(ji,jj,jk,1:jptra)
-                  END DO
+                  IF ( N_in > 0 ) THEN 
+                     DO jk=1,N_in
+                        z_in(jk) = tabres(ji,jj,jk,n2) - tabres(ji,jj,k2,n2)
+                        tabin(jk,1:jptra) = tabres(ji,jj,jk,1:jptra)
+                     END DO
                   
-                  ! Intermediate grid:
-                  DO jk = 1, N_in
-                     h_in_i(jk) = e3t0_parent(ji,jj,jk) * & 
-                       &       (1._wp + tabres(ji,jj,k2,n2)/(ht0_parent(ji,jj)*ssmask(ji,jj) + 1._wp - ssmask(ji,jj)))
-                  END DO
-                  z_in_i(1) = 0.5_wp * h_in_i(1)
-                  DO jk=2,N_in
-                     z_in_i(jk) = z_in_i(jk-1) + 0.5_wp * ( h_in_i(jk) + h_in_i(jk-1) )
-                  END DO
-                  z_in_i(1:N_in) = z_in_i(1:N_in)  - tabres(ji,jj,k2,n2)
-
+                     ! Intermediate grid:
+                     DO jk = 1, N_in
+                        h_in_i(jk) = e3t0_parent(ji,jj,jk) * & 
+                          &       (1._wp + tabres(ji,jj,k2,n2)/(ht0_parent(ji,jj)*ssmask(ji,jj) + 1._wp - ssmask(ji,jj)))
+                     END DO
+                     z_in_i(1) = 0.5_wp * h_in_i(1)
+                     DO jk=2,N_in
+                        z_in_i(jk) = z_in_i(jk-1) + 0.5_wp * ( h_in_i(jk) + h_in_i(jk-1) )
+                     END DO
+                     z_in_i(1:N_in) = z_in_i(1:N_in)  - tabres(ji,jj,k2,n2)
+                  END IF
                   ! Output (Child) grid:
                   N_out = mbkt(ji,jj)
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_top_update.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_top_update.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_top_update.F90	(revision 14200)
@@ -26,4 +26,6 @@
    PUBLIC Agrif_Update_Trc
 
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/NST 4.0 , NEMO Consortium (2018)
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_user.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_user.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_user.F90	(revision 14200)
@@ -365,15 +365,17 @@
          use_sign_north = .TRUE.
          sign_north = -1.
+         CALL Agrif_Bc_variable(ub2b_interp_id,calledweight=1.,procname=interpub2b)   ! must be called before unb_id to define ubdy
+         CALL Agrif_Bc_variable(vb2b_interp_id,calledweight=1.,procname=interpvb2b)   ! must be called before vnb_id to define vbdy
          CALL Agrif_Bc_variable( unb_interp_id,calledweight=1.,procname=interpunb )
          CALL Agrif_Bc_variable( vnb_interp_id,calledweight=1.,procname=interpvnb )
-         CALL Agrif_Bc_variable(ub2b_interp_id,calledweight=1.,procname=interpub2b)   ! must be called before unb_id to define ubdy
-         CALL Agrif_Bc_variable(vb2b_interp_id,calledweight=1.,procname=interpvb2b)   ! must be called before vnb_id to define vbdy
          use_sign_north = .FALSE.
          ubdy(:,:) = 0._wp
          vbdy(:,:) = 0._wp
-      ELSE
+      ELSEIF ( ln_dynspg_EXP ) THEN 
          Agrif_UseSpecialValue = ln_spc_dyn
          use_sign_north = .TRUE.
          sign_north = -1.
+         ubdy(:,:) = 0._wp
+         vbdy(:,:) = 0._wp
          CALL Agrif_Bc_variable( unb_interp_id,calledweight=1.,procname=interpunb )
          CALL Agrif_Bc_variable( vnb_interp_id,calledweight=1.,procname=interpvnb )
@@ -875,4 +877,6 @@
       !
       ! Some checks
+      IF( (.NOT.ln_vert_remap).AND.(jpkglo>Agrif_Parent(jpkglo)) )                    CALL ctl_stop( 'STOP',    &
+         &   'agrif_nemo_init: Agrif children must have less or equal number of vertical levels without ln_vert_remap defined' ) 
       IF( jpiglo /= nbcellsx + 2 + 2*nn_hls + nbghostcells_x   + nbghostcells_x   )   CALL ctl_stop( 'STOP',    &
          &   'agrif_nemo_init: Agrif children requires jpiglo == nbcellsx + 2 + 2*nn_hls + 2*nbghostcells_x' )
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diawri.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diawri.F90	(revision 14199)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diawri.F90	(revision 14200)
@@ -215,7 +215,5 @@
       ENDIF
 
-#if ! defined key_qco
-      CALL iom_put( "rhop", rhop(:,:,:) )          ! 3D potential density (sigma0)
-#endif
+      IF( .NOT.lk_SWE )   CALL iom_put( "rhop", rhop(:,:,:) )          ! 3D potential density (sigma0)
 
       IF ( iom_use("taubot") ) THEN                ! bottom stress
@@ -360,5 +358,5 @@
       ENDIF
       !    
-      IF ( iom_use("sKEf") ) THEN                        ! surface kinetic energy at F point
+      IF ( iom_use("ssKEf") ) THEN                        ! surface kinetic energy at F point
          z2d(:,:) = 0._wp                                ! CAUTION : only valid in SWE, not with bathymetry
          DO_2D( 0, 0, 0, 0 )
@@ -370,5 +368,5 @@
          END_2D
          CALL lbc_lnk( 'diawri', z2d, 'F', 1. )
-         CALL iom_put( "sKEf", z2d )                     
+         CALL iom_put( "ssKEf", z2d )                     
       ENDIF
       !
@@ -473,8 +471,8 @@
       IF (ln_dia25h)   CALL dia_25h( kt, Kmm )        ! 25h averaging
       
-      ! Output of vorticity terms
-      IF ( iom_use("relvor")    .OR. iom_use("plavor")    .OR.   &
-         & iom_use("relpotvor") .OR. iom_use("abspotvor") .OR.   &
-         & iom_use("Ens")                                        ) THEN
+      ! Output of surface vorticity terms
+      IF ( iom_use("ssrelvor")    .OR. iom_use("ssplavor")    .OR.   &
+         & iom_use("ssrelpotvor") .OR. iom_use("ssabspotvor") .OR.   &
+         & iom_use("ssEns")                                        ) THEN
          !
          z2d(:,:) = 0._wp 
@@ -485,7 +483,7 @@
          END_2D
          CALL lbc_lnk( 'diawri', z2d, 'F', 1. )
-         CALL iom_put( "relvor", z2d )                  ! relative vorticity ( zeta ) 
-         !
-         CALL iom_put( "plavor", ff_f )                 ! planetary vorticity ( f )
+         CALL iom_put( "ssrelvor", z2d )                  ! relative vorticity ( zeta ) 
+         !
+         CALL iom_put( "ssplavor", ff_f )                 ! planetary vorticity ( f )
          !
          DO_2D( 1, 0, 1, 0 )  
@@ -498,5 +496,5 @@
          END_2D
          CALL lbc_lnk( 'diawri', z2d, 'F', 1. )
-         CALL iom_put( "relpotvor", z2d )                  ! relative potential vorticity (zeta/h)
+         CALL iom_put( "ssrelpotvor", z2d )                  ! relative potential vorticity (zeta/h)
          !
          DO_2D( 1, 0, 1, 0 )
@@ -509,5 +507,5 @@
          END_2D
          CALL lbc_lnk( 'diawri', z2d, 'F', 1. )
-         CALL iom_put( "abspotvor", z2d )                  ! absolute potential vorticity ( q )
+         CALL iom_put( "ssabspotvor", z2d )                  ! absolute potential vorticity ( q )
          !
          DO_2D( 1, 0, 1, 0 )  
@@ -515,5 +513,5 @@
          END_2D
          CALL lbc_lnk( 'diawri', z2d, 'F', 1. )
-         CALL iom_put( "Ens", z2d )                        ! potential enstrophy ( 1/2*q2 )
+         CALL iom_put( "ssEns", z2d )                        ! potential enstrophy ( 1/2*q2 )
          !
       ENDIF
